## org.apache.poi.hssf.record
Class CalcModeRecord

    java.lang.Object
      org.apache.poi.hssf.record.Record
          org.apache.poi.hssf.record.CalcModeRecord

public class CalcModeRecord
extends Record

Title: Calc Mode Record

Description: Tells the gui whether to calculate formulas automatically, manually or automatically except for tables.

REFERENCE: PG 292 Microsoft Excel 97 Developer's Kit (ISBN: 1-57231-498-2)

Version:
  2.0-pre
Author:
  Andrew C. Oliver (acoliver at apache dot org), Jason Height (jheight at chariot dot net dot au)
See Also:
  `CalcCountRecord`

Field Summary
`static short` `AUTOMATIC` automatically calculate formulas (1)
`static short` `AUTOMATIC_EXCEPT_TABLES` automatically calculate formulas except for tables (-1)
`static short` `MANUAL` manually calculate formulas (0)
`static short` `sid`

Constructor Summary
`CalcModeRecord()`
`CalcModeRecord(short id, short size, byte[] data)` Constructs a CalcModeRecord and sets its fields appropriately
`CalcModeRecord(short id, short size, byte[] data, int offset)` Constructs a CalcModeRecord and sets its fields appropriately

Method Summary
`java.lang.Object` `clone()`
`protected void` `fillFields(byte[] data, short size, int offset)` called by the constructor, should set class level fields.
`short` `getCalcMode()` get the calc mode flag for formulas
`int` `getRecordSize()` gives the current serialized size of the record.
`short` `getSid()` return the non static version of the id for this record.
`int` `serialize(int offset, byte[] data)` called by the class that is responsible for writing this sucker.
`void` `setCalcMode(short calcmode)` set the calc mode flag for formulas
`java.lang.String` `toString()` get a string representation of the record (for biffview/debugging)
`protected void` `validateSid(short id)` called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

Methods inherited from class org.apache.poi.hssf.record.Record
`fillFields, isInValueSection, isValue, processContinueRecord, serialize`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### sid

    public static final short sid

See Also:
  Constant Field Values

### MANUAL

    public static final short MANUAL

  manually calculate formulas (0)

  See Also:
    Constant Field Values

### AUTOMATIC

    public static final short AUTOMATIC

  automatically calculate formulas (1)

  See Also:
    Constant Field Values

### AUTOMATIC_EXCEPT_TABLES

    public static final short AUTOMATIC_EXCEPT_TABLES

  automatically calculate formulas except for tables (-1)

  See Also:
    Constant Field Values

Constructor Detail

### CalcModeRecord

    public CalcModeRecord()

### CalcModeRecord

    public CalcModeRecord(short id,
                          short size,
                          byte[] data)

  Constructs a CalcModeRecord and sets its fields appropriately

Parameters:
  `id` - id must be 0xD or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)

### CalcModeRecord

    public CalcModeRecord(short id,
                          short size,
                          byte[] data,
                          int offset)

  Constructs a CalcModeRecord and sets its fields appropriately

Parameters:
  `id` - id must be 0xD or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)
  `offset` - of the record's start data

Method Detail

### validateSid

    protected void validateSid(short id)

  Description copied from class: `Record`
  called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

  Specified by:
    `validateSid` in class `Record`
  Parameters:
    `id` - alleged id for this record

### fillFields

    protected void fillFields(byte[] data,
                              short size,
                              int offset)

  Description copied from class: `Record`
  called by the constructor, should set class level fields. Should throw runtime exception for bad/icomplete data.

  Specified by:
    `fillFields` in class `Record`
  Parameters:
    `data` - raw data
    `size` - size of data
    `offset` - of the record's data (provided a big array of the file)

### setCalcMode

    public void setCalcMode(short calcmode)

  set the calc mode flag for formulas

  Parameters:
    `calcmode` - one of the three flags above
  See Also:
    `MANUAL`, `AUTOMATIC`, `AUTOMATIC_EXCEPT_TABLES`

### getCalcMode

    public short getCalcMode()

  get the calc mode flag for formulas

  Returns:
    calcmode one of the three flags above
  See Also:
    `MANUAL`, `AUTOMATIC`, `AUTOMATIC_EXCEPT_TABLES`

### toString

    public java.lang.String toString()

  Description copied from class: `Record`
  get a string representation of the record (for biffview/debugging)

  Overrides:
    `toString` in class `Record`

### serialize

    public int serialize(int offset,
                         byte[] data)

  Description copied from class: `Record`
  called by the class that is responsible for writing this sucker. Subclasses should implement this so that their data is passed back in a byte array.

  Specified by:
    `serialize` in class `Record`
  Parameters:
    `offset` - to begin writing at
    `data` - byte array containing instance data
  Returns:
    number of bytes written

### getRecordSize

    public int getRecordSize()

  Description copied from class: `Record`
  gives the current serialized size of the record. Should include the sid and reclength (4 bytes).

  Overrides:
    `getRecordSize` in class `Record`

### getSid

    public short getSid()

  Description copied from class: `Record`
  return the non static version of the id for this record.

  Specified by:
    `getSid` in class `Record`

### clone

    public java.lang.Object clone()

  Overrides:
    `clone` in class `Record`

Copyright © 2003 Apache Software Foundation.